<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGeneralDeviceNote ArrayType
 * @subpackage Arrays
 */
class ArrayOfGeneralDeviceNote extends AbstractStructArrayBase
{
    /**
     * The GeneralDeviceNote
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \CustomerManagement\StructType\GeneralDeviceNote[]
     */
    public $GeneralDeviceNote;
    /**
     * Constructor method for ArrayOfGeneralDeviceNote
     * @uses ArrayOfGeneralDeviceNote::setGeneralDeviceNote()
     * @param \CustomerManagement\StructType\GeneralDeviceNote[] $generalDeviceNote
     */
    public function __construct(array $generalDeviceNote = array())
    {
        $this
            ->setGeneralDeviceNote($generalDeviceNote);
    }
    /**
     * Get GeneralDeviceNote value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \CustomerManagement\StructType\GeneralDeviceNote[]|null
     */
    public function getGeneralDeviceNote()
    {
        return isset($this->GeneralDeviceNote) ? $this->GeneralDeviceNote : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGeneralDeviceNote method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGeneralDeviceNote method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGeneralDeviceNoteForArrayConstraintsFromSetGeneralDeviceNote(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGeneralDeviceNoteGeneralDeviceNoteItem) {
            // validation for constraint: itemType
            if (!$arrayOfGeneralDeviceNoteGeneralDeviceNoteItem instanceof \CustomerManagement\StructType\GeneralDeviceNote) {
                $invalidValues[] = is_object($arrayOfGeneralDeviceNoteGeneralDeviceNoteItem) ? get_class($arrayOfGeneralDeviceNoteGeneralDeviceNoteItem) : sprintf('%s(%s)', gettype($arrayOfGeneralDeviceNoteGeneralDeviceNoteItem), var_export($arrayOfGeneralDeviceNoteGeneralDeviceNoteItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The GeneralDeviceNote property can only contain items of type \CustomerManagement\StructType\GeneralDeviceNote, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set GeneralDeviceNote value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\GeneralDeviceNote[] $generalDeviceNote
     * @return \CustomerManagement\ArrayType\ArrayOfGeneralDeviceNote
     */
    public function setGeneralDeviceNote(array $generalDeviceNote = array())
    {
        // validation for constraint: array
        if ('' !== ($generalDeviceNoteArrayErrorMessage = self::validateGeneralDeviceNoteForArrayConstraintsFromSetGeneralDeviceNote($generalDeviceNote))) {
            throw new \InvalidArgumentException($generalDeviceNoteArrayErrorMessage, __LINE__);
        }
        if (is_null($generalDeviceNote) || (is_array($generalDeviceNote) && empty($generalDeviceNote))) {
            unset($this->GeneralDeviceNote);
        } else {
            $this->GeneralDeviceNote = $generalDeviceNote;
        }
        return $this;
    }
    /**
     * Add item to GeneralDeviceNote value
     * @throws \InvalidArgumentException
     * @param \CustomerManagement\StructType\GeneralDeviceNote $item
     * @return \CustomerManagement\ArrayType\ArrayOfGeneralDeviceNote
     */
    public function addToGeneralDeviceNote(\CustomerManagement\StructType\GeneralDeviceNote $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \CustomerManagement\StructType\GeneralDeviceNote) {
            throw new \InvalidArgumentException(sprintf('The GeneralDeviceNote property can only contain items of type \CustomerManagement\StructType\GeneralDeviceNote, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->GeneralDeviceNote[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \CustomerManagement\StructType\GeneralDeviceNote|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \CustomerManagement\StructType\GeneralDeviceNote|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \CustomerManagement\StructType\GeneralDeviceNote|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \CustomerManagement\StructType\GeneralDeviceNote|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \CustomerManagement\StructType\GeneralDeviceNote|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string GeneralDeviceNote
     */
    public function getAttributeName()
    {
        return 'GeneralDeviceNote';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\ArrayType\ArrayOfGeneralDeviceNote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
